%global srcname     lumina
#global relsuffix   .p1
%global srcsuffix   %(r=%{?relsuffix}; echo $r |tr . - )

Summary:            A lightweight, portable desktop environment
Name:               %{srcname}-desktop
Version:            1.5.0
Release:            1.2%{?relsuffix}%{?dist}
License:            BSD
URL:                http://%{name}.org
Source0:            https://github.com/trueos/%{srcname}/archive/v%{version}%{srcsuffix}.tar.gz#/%{srcname}-%{version}%{srcsuffix}.tar.gz
Source1:            mageia-lang.tar

%if 0%{?fedora}
Patch1:             fedora-customatization.patch
%endif


# Compiler requirements
BuildRequires:        lsb-core-noarch
BuildRequires:        desktop-file-utils

# Qt requirements
BuildRequires:        pkgconfig(Qt5Help)
BuildRequires:        pkgconfig(Qt5Designer)
BuildRequires:        pkgconfig(Qt5Concurrent)
BuildRequires:        pkgconfig(Qt5Core)
BuildRequires:        pkgconfig(Qt5DBus)
BuildRequires:        pkgconfig(Qt5Gui)
BuildRequires:        pkgconfig(Qt5Network)
BuildRequires:        pkgconfig(Qt5OpenGL)
BuildRequires:        pkgconfig(Qt5PrintSupport)
BuildRequires:        pkgconfig(Qt5Sql)
BuildRequires:        pkgconfig(Qt5Test)
BuildRequires:        pkgconfig(Qt5Widgets)
BuildRequires:        pkgconfig(Qt5Xml)
BuildRequires:        pkgconfig(Qt5Multimedia)
BuildRequires:        pkgconfig(Qt5MultimediaWidgets)
BuildRequires:        pkgconfig(Qt5Qml)
BuildRequires:        pkgconfig(Qt5Quick)
BuildRequires:        pkgconfig(Qt5QuickTest)
BuildRequires:        pkgconfig(Qt5QuickWidgets)
BuildRequires:        pkgconfig(Qt5Svg)
BuildRequires:        pkgconfig(Qt5X11Extras)
%if 0%{?fedora} == 30
BuildRequires:        qt5-qtbase-private-devel
%endif

#needed for liblthemeengine.so
BuildRequires:        pkgconfig(Qt5OpenGLExtensions)
BuildRequires:        pkgconfig(udev)
BuildRequires:        pkgconfig(libudev)

# X component requirements
BuildRequires:        pkgconfig(xcb-image)
BuildRequires:        pkgconfig(xcb-ewmh)
BuildRequires:        pkgconfig(xcb-icccm)
BuildRequires:        pkgconfig(xcb)
BuildRequires:        pkgconfig(xcb-util)
BuildRequires:        pkgconfig(xcomposite)
BuildRequires:        pkgconfig(xdamage)
BuildRequires:        pkgconfig(xrender)
BuildRequires:        pkgconfig(xi)
BuildRequires:        pkgconfig(xrandr)
BuildRequires:        pkgconfig(xcursor)
BuildRequires:        pkgconfig(libpulse)
BuildRequires:        pkgconfig(x11-xcb)
BuildRequires:        pkgconfig(hunspell)

#####
%if 0%{?mageia}
BuildRequires:        kf5-macros
BuildRequires:        lib64qt5themesupport-static-devel
%endif

# Runtime requirements
%if 0%{?fedora}
Requires:           oxygen-cursor-themes
%endif
Requires:           fluxbox
Requires:           qt5-style-oxygen
Requires:           adwaita-cursor-theme

Requires:           %{name}-filesystem = %{version}-%{release}
Requires:           %{name}-data = %{version}-%{release}
Requires:           %{srcname}-open = %{version}-%{release}
Requires:           %{srcname}-info = %{version}-%{release}
Requires:           %{srcname}-theme-engine = %{version}-%{release}

# Desktop extensions
%if 0%{?fedora}
Suggests:           %{srcname}-config = %{version}-%{release}
Suggests:           %{srcname}-xconfig = %{version}-%{release}
Suggests:           %{srcname}-search = %{version}-%{release}
Suggests:           %{srcname}-archiver = %{version}-%{release}
Suggests:           %{srcname}-fileinfo = %{version}-%{release}
Suggests:           %{srcname}-fm = %{version}-%{release}
Suggests:           %{srcname}-mediaplayer = %{version}-%{release}
Suggests:           %{srcname}-screenshot = %{version}-%{release}
Suggests:           %{srcname}-textedit = %{version}-%{release}
Suggests:           %{srcname}-icons = %{version}-%{release}
%endif

# OS specific recomends
%if 0%{?fedora}
Recommends:  pavucontrol,dnfdragora,xscreensaver,qterminal
%endif


%description
The Lumina Desktop Environment is a lightweight system interface
that is designed for use on any Unix-like operating system.

%package            filesystem
Summary:            Common folders for Lumina Desktop
BuildArch:          noarch
Obsoletes:          %{name}-libs < 1.2.0
Obsoletes:          %{srcname}-xdg-entry < 1.4.1 

%description        filesystem
This package provides the common folders for the Lumina Desktop Environment.

%package            data
Summary:            Data for Lumina Desktop
BuildArch:          noarch
Requires:           %{name}-filesystem = %{version}-%{release}

%description        data
This package provides the data files for the Lumina Desktop
Environment: Colors, desktop background, theme templates.

%package -n         %{srcname}-open
Summary:            xdg-open style utility for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-open
This package provides %{srcname}-open, which handles opening of
files and URLs according to the system-wide mimetype association.
It also provides an optional selector if more than one application
is assigned with the given url or file type.

%package -n         %{srcname}-info
Summary:            Basic information utility for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-info
This package provides %{srcname}-info, which is a simple
utility that displays various information about the Lumina
installation, like paths, contributors, license or version.


%package -n         %{srcname}-config
Summary:            Configuration utility for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-config
This package provides %{srcname}-config, which allows changing
various aspects of %{srcname} and fluxbox, like the wallpaper being
used, theme, icons, panel (and plugins), startup and default
applications, desktop menu and more.

%package -n         %{srcname}-xconfig
Summary:            X server display configuration tool for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-xconfig
This package provides %{srcname}-xconfig, which is a simple
multi-head aware display configuration tool for configuring
the X server.

%package -n         %{srcname}-search
Summary:            Search utility for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-search
This package provides %{srcname}-search, which is a simple
search utility that allows to search for applications or
files and directories in the home directory and launch
or open them.

%package -n         %{srcname}-archiver
Summary:            Archiver for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-archiver
Front-end to tar, used for managing/creating archives.

%package -n         %{srcname}-fileinfo
Summary:            Desktop file editor for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-fileinfo
File properties viewer, and simple XDG application registration creator.

%package -n         %{srcname}-fm
Summary:            File manager for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-fm
This package provides %{srcname}-fm, which is a simple file manager
with support for multiple view modes, tabbed browsing,
including an integrated slideshow-based picture viewer.

%package -n         %{srcname}-mediaplayer
Summary:            Mediaplayer for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-mediaplayer
Simple media player with hooks for streaming from online radio services.

%package -n         %{srcname}-screenshot
Summary:            Screenshot utility for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-screenshot
This package provides %{srcname}-screenshot, which is a simple
screenshot utility that allows to snapshot the whole desktop
or a single window after a configurable delay.

Optionally the window border can be hidden when taking a
screenshot of a single window.

%package -n         %{srcname}-textedit
Summary:            Text file editor for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-textedit
Plaintext editor with syntax highlighting, tab support, and find/replace functionality.

%package            icons
Summary:            Icons for Lumina Desktop
BuildArch:          noarch
Requires:           filesystem

%description        icons
Optional icons themes recommended for Lumina Desktop.


%package -n %{srcname}-theme-engine
Summary:               This is a theme engine for the Lumina Desktop
Requires:             %{name} = %{version}-%{release}
%description -n %{srcname}-theme-engine
This is a theme engine for the Lumina Desktop

%package -n         %{srcname}-photo
Summary:            This is an image viewer for Lumina Desktop
Requires:           %{name}-filesystem = %{version}-%{release}

%description -n     %{srcname}-photo
Image viewer for the Lumina Desktop

########################################################################################
%prep
%autosetup -n%{srcname}-%{version}%{srcsuffix} -p1
desktop-file-edit --remove-key=Categories --remove-only-show-in=Lumina --add-only-show-in=X-Lumina \
 src-qt5/core/%{srcname}-info/%{srcname}-support.desktop
for i in `grep -lir 'OnlyShowIn=Lumina' src-qt5`
do
 desktop-file-edit --remove-only-show-in=Lumina --add-only-show-in=X-Lumina $i
done

sed -i 's/\(-lXcursor\)/-lX11 \1/' src-qt5/core/lumina-theme-engine/src/lthemeengine-qtplugin/lthemeengine-qtplugin.pro

%build
mkdir -p %{_target_platform}
pushd %{_target_platform}
  %qmake_qt5 ..  \
      CONFIG+="configure" \
      CONFIG+="WITH_I18N" \
      PREFIX="%{_prefix}" \
      LIBPREFIX="%{_libdir}" \
      QT5LIBDIR="%{_qt5_prefix}" \
      L_MANDIR="%{_mandir}" \
      L_ETCDIR=%{_sysconfdir} \
      QMAKE_CFLAGS_ISYSTEM= \
      QMAKE_LFLAGS+="-Wl,--as-needed"

popd

%make_build -C %{_target_platform}


%install
%make_install INSTALL_ROOT=%{buildroot} -C %{_target_platform}



#Remove execute bit from icon
chmod -x  %{buildroot}%{_datadir}/icons/material-design-dark/scalable/*/*.svg
chmod -x  %{buildroot}%{_datadir}/icons/material-design-light/scalable/*/*.svg


# split locales into subpackages
%if 0%{?mageia} == 6
tar -xf %{SOURCE1}
%else
%find_lang %{name} --with-qt
%find_lang %{srcname}-info --with-qt
%find_lang %{srcname}-open --with-qt
%find_lang %{srcname}-config --with-qt
%find_lang %{srcname}-search --with-qt
%find_lang %{srcname}-xconfig --with-qt
%find_lang l-archiver --with-qt
%find_lang l-fileinfo --with-qt
%find_lang %{srcname}-fm --with-qt
%find_lang l-mediap --with-qt
%find_lang l-screenshot --with-qt
%find_lang l-te --with-qt
%find_lang l-photo --with-qt
%endif


%check
desktop-file-validate %{buildroot}%{_datadir}/applications/%{srcname}-*.desktop

########################################################################################
# TODO: add licenses

%files -f %{name}.lang
%license LICENSE
%{_bindir}/%{name}
%{_bindir}/start-%{name}
%config %{_sysconfdir}/%{srcname}Desktop.conf.dist
%{_datadir}/xsessions/Lumina-DE.desktop
%{_datadir}/applications/%{srcname}-support.desktop
%{_datadir}/icons/hicolor/scalable/apps/Lumina-DE.png
%{_mandir}/man8/start-lumina-desktop.8.*z
%{_mandir}/man1/lumina-desktop.1.*z

%files filesystem
# each binary expects its locale files in the common folder
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/i18n

%files data
%{_datadir}/%{name}/
%exclude %{_datadir}/%{name}/i18n

%files -n %{srcname}-open -f %{srcname}-open.lang
%{_bindir}/%{srcname}-open
%{_mandir}/man1/lumina-open.1.*z

%files -n %{srcname}-info -f %{srcname}-info.lang
#license LICENSE
%{_bindir}/%{srcname}-info
%{_datadir}/applications/%{srcname}-info.desktop
%{_mandir}/man1/lumina-info.1.*z

%files -n %{srcname}-config -f %{srcname}-config.lang
%{_bindir}/%{srcname}-config
%{_datadir}/applications/%{srcname}-config.desktop
%{_mandir}/man1/lumina-config.1.*z

%files -n %{srcname}-xconfig -f %{srcname}-xconfig.lang
%{_bindir}/%{srcname}-xconfig
%{_datadir}/applications/%{srcname}-xconfig.desktop
%{_mandir}/man1/lumina-xconfig.1.*z


%files -n %{srcname}-search -f %{srcname}-search.lang
%{_bindir}/%{srcname}-search
%{_datadir}/applications/%{srcname}-search.desktop
%{_mandir}/man1/lumina-search.1.*z

%files -n %{srcname}-archiver -f l-archiver.lang
%{_bindir}/%{srcname}-archiver
%{_datadir}/applications/%{srcname}-archiver.desktop
%{_mandir}/man1/lumina-archiver.1.*z

%files -n %{srcname}-fileinfo -f l-fileinfo.lang
%{_bindir}/%{srcname}-fileinfo
%{_datadir}/applications/%{srcname}-fileinfo.desktop
%{_mandir}/man1/lumina-fileinfo.1.*z

%files -n %{srcname}-fm -f %{srcname}-fm.lang
%{_bindir}/%{srcname}-fm
%{_datadir}/icons/hicolor/scalable/apps/Insight-FileManager.png
%{_datadir}/applications/%{srcname}-fm.desktop
%{_mandir}/man1/lumina-fm.1.*z

%files -n %{srcname}-mediaplayer -f l-mediap.lang
%{_bindir}/%{srcname}-mediaplayer
%{_datadir}/applications/%{srcname}-mediaplayer.desktop
%{_datadir}/applications/lumina-mediaplayer-pandora.desktop
%{_mandir}/man1/lumina-mediaplayer.1.*z

%files -n %{srcname}-screenshot -f l-screenshot.lang
%{_bindir}/%{srcname}-screenshot
%{_datadir}/applications/%{srcname}-screenshot.desktop
%{_mandir}/man1/lumina-screenshot.1.*z

%files -n %{srcname}-textedit -f l-te.lang
# W: dangling-symlink /usr/bin/lte /usr/bin/lumina-textedit
%exclude %{_bindir}/lte
%{_bindir}/%{srcname}-textedit
%{_datadir}/applications/%{srcname}-textedit.desktop
%{_mandir}/man1/lumina-textedit.1.*z

%files icons
%{_datadir}/icons/material-design-dark/
%{_datadir}/icons/material-design-light/

%files -n %{srcname}-theme-engine
%{_bindir}/lthemeengine
%{_bindir}/lthemeengine-sstest
%{_datadir}/lthemeengine/colors/*.conf
%{_datadir}/lthemeengine/desktop_qss/
%{_datadir}/lthemeengine/qss/
%{_datadir}/applications/lthemeengine.desktop
%{_qt5_plugindir}/platformthemes/liblthemeengine.so
%{_qt5_plugindir}/styles/liblthemeengine-style.so

%files -n %{srcname}-photo
%{_bindir}/lumina-photo
%{_datadir}/applications/%{srcname}-photo.desktop
%{_mandir}/man1/lumina-photo.1.*z

########################################################################################
%changelog
* Tue May 07 2019 Martin - 1.5.0-0.2
- Add xdg-entry obsolute

* Mon May 06 2019 Martin - 1.5.0-0.1
- Version bump
- add subpackage for lumina-photo
- remove lumina-pdf and lumina-calculator lumina-xdg-entry

* Fri Mar 15 2019 Martin - 1.4.0-0.4.p1
- rebuilt

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.0-3.p1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sun Sep 3 2017 TI_Eugene <ti.eugene@gmail.com> - 1.3.0-2.p1
- *.desktop patches tuned

* Sun Sep 3 2017 TI_Eugene <ti.eugene@gmail.com> - 1.3.0-1.p1
- Version bump
- Added mediaplayer, xdg-entry and icons subpackages
- Extra locales source removed

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.0-4.p1.Ld700dea
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.0-3.p1.Ld700dea
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Wed Apr 19 2017 Raphael Groner <projects.rg@smart.ms>
- fix dependency to filesystem subpackage, it is noarch
- add archiver subpackage to suggestions

* Tue Apr 11 2017 TI_Eugene <ti.eugene@gmail.com> - 1.2.0-1.p1.Ld700dea
- Version bump
- Added archiver subpackage
- libs subpackage renamed into filesystem
- Removed empty devel subpackage

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.0-2.p1.Ld700dea
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Fri Dec 09 2016 Raphael Groner <projects.rg@smart.ms> - 1.1.0-1.p1.Ld700dea
- new version
- add subpackage for calculator
- fix for rhbz#1389486, R: lumina-open

* Mon Sep 26 2016 Raphael Groner <projects.rg@smart.ms> - 1.0.0-5.p2.Lbc08e90
- fix typo

* Sun Sep 25 2016 Raphael Groner <projects.rg@smart.ms> - 1.0.0-4.p2.Lbc08e90
- thin out dependencies, no assumptions about used applications

* Sat Sep 24 2016 Raphael Groner <projects.rg@smart.ms> - 1.0.0-3.p2.Lbc08e90
- drop ExcludeArch
- try to fix unused-direct-shlib-dependency

* Sat Aug 27 2016 Raphael Groner <projects.rg@smart.ms> - 1.0.0-2.p2.Lbc08e90
- update to patchset 2
- fix E: script-without-shebang
- [epel] fix creation of folder etc

* Sun Aug 14 2016 Raphael Groner <projects.rg@smart.ms> - 1.0.0-1.p1.Lbc08e90
- use official upstream release
- clean up build deps
- update translations from git
- drop langpacks and include in binary subpackages
- disable weak dependencies for epel

* Sun Aug 07 2016 Raphael Groner <projects.rg@smart.ms> - 1.0.0-0.3.Beta4.Tfbab63e
- Beta4

* Sun Aug 07 2016 Raphael Groner <projects.rg@smart.ms> - 1.0.0-0.2.Beta2.Tfbab63e
- avoid dangling-symlink /usr/bin/lte
- drop implicit BR: gcc
- drop Group tags
- compile translations and split into individual langpacks

* Fri Jul 15 2016 Raphael Groner <projects.rg@smart.ms> - 1.0.0-0.1.Beta2
- version 1.0.0 Beta2
- prepare for review
- split more subpackages: i18n, wallpapers

* Wed Dec 23 2015 Neal Gompa <ngompa13@gmail.com>
- Update to 0.8.8
- Bring it closer to Fedora guidelines
- Break out Lumina Desktop package into subpackages
- Unify 32-bit and 64-bit packaging

* Tue Oct 27 2015 Jesse Smith <jsmith@resonatingmedia.com>
- Update to 0.8.7

* Thu Aug 20 2015 Jesse Smith <jsmith@resonatingmedia.com>
- Updated for 32-bit

* Thu Jul 30 2015 Jesse Smith <jsmith@resonatingmedia.com>
- Initial build
